﻿using System;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 커서 상태 표시하기 - ShowCursorState()

        /// <summary>
        /// 커서 상태 표시하기
        /// </summary>
        private static void ShowCursorState()
        {
            Console.Clear();

            Console.ResetColor();

            Console.WriteLine("H   : 커서 숨기기"   );
            Console.WriteLine("S   : 커서 표시"     );
            Console.WriteLine("X   : 커서 높이 증가");
            Console.WriteLine("ESC : 종료"          );

            Console.WriteLine();

            Console.ForegroundColor = ConsoleColor.Yellow;

            Console.WriteLine(Console.CursorVisible ? "커서 표시" : "커서 숨김");

            Console.WriteLine("커서 크기 : {0}%", Console.CursorSize);

            Console.WriteLine();

            Console.SetCursorPosition(0, 5);
        }

        #endregion
        #region 콘솔 키 처리하기 - ProcessConsoleKey(consoleKey)

        /// <summary>
        /// 콘솔 키 처리하기
        /// </summary>
        /// <param name="consoleKey">콘솔 키</param>
        private static void ProcessConsoleKey(ConsoleKey consoleKey)
        {
            switch(consoleKey)
            {
                case ConsoleKey.H :

                    Console.CursorVisible = false;

                    break;

                case ConsoleKey.S :

                    Console.CursorVisible = true;

                    break;

                case ConsoleKey.X :

                    Console.CursorSize = Console.CursorSize == 100 ? 1 : Console.CursorSize + 1;

                    break;
            }
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            ConsoleKey consoleKey;

            Console.Title = "Cursor Display Sample";

            do
            {
                ShowCursorState();

                consoleKey = Console.ReadKey(true).Key;

                ProcessConsoleKey(consoleKey);
            }
            while(consoleKey != ConsoleKey.Escape);
        }

        #endregion
    }
}